
/* Kirk Christiansen */
/* KC_PCSND.C        */

/* Sound module for PC speaker sounds */
/***********************************************************************/
#ifndef _KC_PCSND
/***********************************************************************/
enum sound_types {NO_SOUND_MADE,POWER_UP_PICKUP,SMALL_EXPLOSION,
		  BIG_EXPLOSION,LEVEL_CLEAR,ILLEGAL_MOVE,CRASHED_PROJ,
		  INTRO_MUSIC, TELEPORT_SND, LEVEL_WARP, ALARM1,
		  WIERDEVENT,SADMUSIC,WINMUSIC};
/***********************************************************************/
/* Function Prototypes */
void make_sound(int soundis);
void make_power_up_pickup_sound(void);
void make_small_explosion_sound(void);
void make_big_explosion_sound(void);
void make_level_clear_sound(void);
void make_illegal_move_sound(void);
void make_crashed_proj_sound (void);
void make_teleport_sound (void);
void make_level_warp_sound (void);
void make_alarm1_sound (void);
void make_wierdevent_sound (void);
void make_sadmusic_sound (void);
void make_winmusic_sound (void);
void play_intro_music(void);
/***********************************************************************/
void make_sound(int soundis)
/* This function takes in as input a sound type, explosion whatever */
/* it then calls the appropriate function to make the sound.        */
{
     switch (soundis)
      {
	case POWER_UP_PICKUP :  make_power_up_pickup_sound();
				break;
	case SMALL_EXPLOSION :  make_small_explosion_sound();
				break;
	case BIG_EXPLOSION   :  make_big_explosion_sound();
				break;
	case LEVEL_CLEAR     :  make_level_clear_sound();
				break;
	case ILLEGAL_MOVE    :  make_illegal_move_sound();
				break;
	case CRASHED_PROJ    :  make_crashed_proj_sound();
				break;
	case INTRO_MUSIC     :  play_intro_music();
				break;
	case TELEPORT_SND    :  make_teleport_sound();
				break;
	case LEVEL_WARP      :  make_level_warp_sound();
				break;
	case ALARM1          :  make_alarm1_sound();
				break;
	case WIERDEVENT      :  make_wierdevent_sound();
				break;
	case SADMUSIC        :  make_sadmusic_sound();
				break;
	case WINMUSIC        :  make_winmusic_sound();
				break;
      };

	/* Make sure I turn off the PC speaker */
	  nosound();
}
/***********************************************************************/
void make_power_up_pickup_sound(void)
{
  int i,j;


    for (j=0;j<3;j++)
     {
      for (i=0;i<5;i++)
       {
	if (i%2)
	  sound (1000+(j*100));
	else
	  sound (1200+(j*200));
	delay(7);
       }
     }
}
/***********************************************************************/
void make_small_explosion_sound(void)
{
  sound (180); delay(12);
  sound (200); delay(8);
}
/***********************************************************************/
void make_big_explosion_sound(void)
{
  sound (200); delay (80);
  sound (400); delay (60);
  sound (300); delay (40);
}
/***********************************************************************/
void make_level_clear_sound(void)
{
  sound (380); delay (150);
  sound (580); delay (150);
  sound (880); delay (300);
}
/***********************************************************************/
void make_illegal_move_sound(void)
{
  sound(70); delay(20);
}
/***********************************************************************/
void make_crashed_proj_sound (void)
{
  sound (100); delay (20); nosound();
}
/***********************************************************************/
void play_intro_music(void)
{
 int i;

 sound (200);
 delay (500);
 sound (800);
 delay (250);
 sound (1000);
 delay (400);
}
/***********************************************************************/
void make_teleport_sound (void)
{
  int j;

  for (j=1200;j>=50;j-=60)
     {
       sound(j); delay(9);
     }
}
/***********************************************************************/
void make_level_warp_sound (void)
{
  int j;

    for (j=100;j<1800;j+=22)
      {
	sound(j); delay(9);
      }
}
/***********************************************************************/
void make_alarm1_sound (void)
{
  int i,j;

    for (i=0;i<3;i++)
     {
       for (j=100;j<1700;j+=25)
	{
	 sound(j); delay(9); //nosound(); //do i need nosound? here
	}
       delay(5);
     }
}
/***********************************************************************/
void make_wierdevent_sound (void)
{
  int i,j;

    for (i=0;i<3;i++)
     {
       for (j=100;j<1700;j+=100)
	{
	 sound(j); delay(1); //nosound(); //do i need nosound? here
	}
       delay(1);
     }
}
/***********************************************************************/
void make_sadmusic_sound (void)
{
  sound (300); delay (250);
  //nosound();delay(15);
  sound (200); delay (350);
  nosound();delay(10);
  sound (150); delay (650);
}
/***********************************************************************/
void make_winmusic_sound (void)
{
  sound (380); delay (150);
  sound (580); delay (150);
  sound (880); delay (300);
  sound (1000); delay (500);
}
/***********************************************************************/
#define _KC_PCSND
#endif