
/* Kirk Christiansen */
/* QUEUEOPS.C        */

/* This module contains functions     */
/* for operations on queue's.         */
/* The input buffer of a tank in      */
/* Tankgame is handled by like a      */
/* queue (i.e  first-in...first-out). */

#ifndef _QUEUEOPS.C
/*************************************************************************/
#include "tankvars.c"
/*************************************************************************/
/* Function Prototypes */
void add_buffer(int tanknum, unsigned newmove);
void remove_buffer(int tanknum);
/*************************************************************************/
void add_buffer(int tanknum, unsigned newmove)
/* This function simply adds an element to a tank's input    */
/* buffer array.  Elements are added to the end of the queue */
{
 int x;

   for (x=0; x < MAXBUFFERSIZE; x++)
      {
	/* if there is room to add the newmove */
	 if (tanks[tanknum].inputbuffer[x]==0)
	     {
	       tanks[tanknum].inputbuffer[x]=newmove;
	       return;  /* return so I don't set the whole buffer */
	     }
       }
}

/*************************************************************************/
void remove_buffer(int tanknum)
/* This function simply removes an element from a tank's input     */
/* buffer array.  Elements are removed from the front of the queue */
{
 int x;

     /* pop the move off the buffer, store it in current input */
     tanks[tanknum].currentinput = tanks[tanknum].inputbuffer[0];


     /* shift the rest of the elements down */
     for (x=0; x < (MAXBUFFERSIZE - 1); x++)
	{
	  tanks[tanknum].inputbuffer[x]=tanks[tanknum].inputbuffer[x+1];
	}

     /* Next line gave me a superbug cuz I had it MAXBUFFERSIZE, */
     /* instead of MAXBUFFERSIZE-1. And it was setting my first  */
     /* projectile's  direction equal to 0!!!!                   */
     tanks[tanknum].inputbuffer[MAXBUFFERSIZE-1]=0;
}
/***************************************************************************/
#define _QUEUEOPS.C
#endif
