
/* Kirk Christiansen */
/* TANKDOC.C         */

/* This external module is just all the documentation    */
/* that has been compiled during the making of TANKGAME. */

/**************************************************************************/
/* MODE 13h VERSION  */
/* Tank Combat Game  */
/* VERSION : 5.0    */

/* NEW FEATURES :    */
/* -Made the Tanks Array GLOBAL */
/* -Added Power-up pills to gain armor & weapons */
/* -Redesigned stat box for player only to display */
/*  current weapon, weapon inventory, live count,  */
/*  and current weapon ammo count.                 */
/* -Added sound & weapon module                    */
/* -Added rebounding shells! This was a big improvement */
/* -Added time limit on projectiles                */
/* -Converted to tick time scale.                  */
/* -Added Piercing Shells!                         */
/* -Added a sound module "TNKSOUND.C" for modularity */
/* -Made some Fade patterns to be displayed between levels */
/* -Made tanks able to move through projectiles */
/* -ADDED 3d effect to boards  */
/* -Added tons of new boards w/ teleporters on some */

/* FINAL VERSION FEATURES */
/* -My own keyboard handler */
/* -New Configuration Menu system with : SELECT board feature */
/* -2 Player MATCH mode! 2 people using same keyboard fight each other */
/* New game loop time consistancy */
/* New status bars on bottom of screen */
/* Vertical retrace wait.  Pick difficulty of Game. Choose Tank types */
/* 2 Player FULLGAME mode!  fun stuff */
/* DUEL fighting options: invisible tnks/pwrups_on/nitefight/display stats */
/* Cheat code flag. New Endings. New tanktype CIRCLETANK. */
/* ADDED JOYSTICK SUPPORT! + calibration routine and automatic calibration */
/* Cheat codes : toggle individual tank invisiblity, armor, skip levels */
/*               stop computer tanks, toggle palette. */
/* Finished up to 13 levels, including complicated teleport boards */
/* Added CPU speed check. Use this to determine some for loop lengths */
/* Added 2 additional pages of Tankgame info, about me and the game.  */
/* Finished Null Modem Linkup functions */

/* Went from Small Model to Large Model using this command line compiler */
/* input >  tcc -ml tankgame.c kctnkasm.obj */
/* This solved my _TEXT_SEGMENT too large error */

/* Found a terminator bug where it would just go after tanks[0]. Cuz of  */
/* a semicolon after a for loop! */

/* As of 12-1-95, I got feedback from initial version, so I came back */
/* and made the game alot easier to beat, cuz people said it was too  */
/* hard.  So I added PATROL Heuristic which is a dumb NAIVE style.    */
/* And I made tanks have less armor, etc.                             */

/* As of 12-4-95, I got feedback from 2nd beta version. Game was much */
/* more playable, but people still wanted a PLAY AGAIN? option, so    */
/* I added this.  Continued running into GLOBAL DECLARATIONS exceed   */
/* 64k error, so I went to a new compile option :                     */
/*    tcc -ml -O tankgame.c kctnkasm.obj                              */
/* which cured the problem.  Plus I added the -d switch which optimizes */
/* duplicated strings and this saved me approx. 1k on the final .EXE.  */

/* As of 12-6-95, I tested the 3rd beta w/Sam and decided it needed  */
/* some additional revamping.  I just revamped the .EXE.  I made the */
/* memory more efficient, so if a computer only has 349,000 bytes free */
/* it can still show my pict, and the controls.  I also made sure all */
/* the memory was released upon the game ending.  Also I redid some of */
/* the status report, and the game now aborts if not enough memory is */
/* available at beginning.  I also added a new secret code so you can */
/* have a 2-player duel on the 13th level.   And I made minor revisions */
/* to the duel's powerup numbers, values, and locations.              */
/* Also: Made startup display status report by default.               */

/* Took out SMARTTNK.C attackmode cuz It wasn't perfected and I didn't */
/* use it at for computer tank heuristics. */
/* Found Projectile Bug, where the projectiles would fire then die right */
/* away. This was because proj's 'time' was of type int, which would  */
/* only go up to like 32,000, which would be about 20-25 mins *  60 secs */
/* per min * 18.2 ticks per sec.  So I set it to unsigned int to double */
/* the alloted time of game.  I could increase this to long if wanted. */
/* NOTE: explosion's had the same bug! I just didn't notice it before. */

/* Final version : Approx Work Hours: 261 (as of 12/4/95(700am)) */
/* Entire Game was Created from March 1995 to December 1995      */
/**************************************************************************/
/* CREATION NOTES */

/* Tankgame runs at 18.2 ticks (standard) per second or 18 frames */
/* second.  So I did not reprogram the timer. */

/* PCX FILE CONVERSIONS FOR INFO HIDING */
/*  mytanks.pcx  -> tnkgm0.dat */
/*  tnkintro.pcx -> tnkgm1.dat */
/*  tankmsc1.pcx -> tnkgm2.dat */
/*  tankmsc2.pcx -> tnkgm3.dat */
/*  tankmenu.pcx -> tnkgm4.dat */
/*  kcpict.pcx   -> tnkgm5.dat */
/*  tnkctrls.pcx -> tnkgm6.dat */
/*  tankbars.pcx -> tnkgm7.dat */

/* CHEAT CODES */
/* 1) Pick 2-Player Duel with RANDOM board selection.  While you hit */
/*    Start make sure you are holding the 'T' key down.              */
/* 2) Hit B,O,Z, and Y, simultaneously during gameplay.  You will hear */
/*    a faint beep.  Then You can do the following :                   */
/*        (a)  Hit A&R (player1) or M&O (player2) simultaneously to    */
/*             increase armor.                                         */
/*        (b)  Hit F3 To advance a level, F4 to go back a level.       */
/*        (c)  Hit F2 for palette toggle (night palette must be loaded) */
/*        (d)  Hit T&C simulataneously to Turn On/Off Computer Tanks.   */
/*        (e)  Hit I & (0 or 1) simulateneously to Toggle a Tank's      */
/*             invisibility's status On/Off.                            */
/*        (f)  Hit + to goto 13th level, - to goto 1st level.           */
/**************************************************************************/
