
/* Kirk Christiansen */
/* TANKMENU.C        */

/* This module contains the code for displaying */
/* and navigating the menus for Tank Game */

#ifndef _TANKMENU
#define _TANKMENU
/**************************************************************************/
#include "tankvars.c"
#include "kcgrphcs.c"
#include "kc_keybd.c"
#include "kc_jstck.c"
#include "tnkpicts.c"
#include "miscfncs.c"

#define HIGHCOLOR  75  /* highlighted color */
#define LOWCOLOR  35  /* low-lighted color */
/**************************************************************************/
/* Global variables (buttons etc) */
int left_bttn=0;  /* 0-5 / menu_picts 14-18 */
int gmtyp_bttn=0;    /* 0-3 */
int slct_bttn=0;    /* 0-2 */
int cnfg_bttn=0;    /* 0-2*/
int view_bttn=0;     /*0-2*/

int board_selected=VOID; /* stores which board the user wanted to play */
int duel_options[4]={FALSE,TRUE,FALSE,TRUE}; /* stores the 4 duel options */
int quit_main_menu=FALSE;  /* var that represents the quit menu flag */
/**************************************************************************/
void display_configuration_menu(void);
void display_board_select_screen(void);
void display_picture_of_me(void);
void display_instructions(void);
void display_duel_options(void);
void display_difficulty_options(void);
void display_choose_tank_type_screen(void);
void display_sound_info(void);
void configure_joystick(void);
void display_game_info1(void);
void display_game_info2(void);
void display_game_info3(void);
void get_null_modem_info(void);
/**************************************************************************/
void display_configuration_menu(void)
/* This function shows the game player the configuration options, like */
/* Input device choices, and joystick calibration etc...               */
{
   /* make sure quit_main_menu=FALSE */
   quit_main_menu=FALSE;

   do
   {
     /*  blit the menu */
     blit (0,0,320,200,screen_buffer,pcx[TANKMENU].image);
     /* Blit the current turned on buttons */
     /* first, the left side on button */
    blit(0,26+(left_bttn*35),100,34,screen_buffer,menu_picts[left_bttn+14]);
     /* blit the Game Type button */
    blit(105+(gmtyp_bttn*54),34,48,18,screen_buffer,menu_picts[gmtyp_bttn+1]);
     /* blit the Select button */
    blit(114+(slct_bttn*70),69,53,18,screen_buffer,menu_picts[slct_bttn+5]);
     /* blit the setup selection button */
    blit(114+(cnfg_bttn*70),104,53,18,screen_buffer,menu_picts[cnfg_bttn+8]);
     /* blit the player 2 current input device button */
    blit(114+(view_bttn*70),139,53,18,screen_buffer,menu_picts[view_bttn+11]);

     /* if left side button is 2,3, or 4, tell user to hit enter */
     if (left_bttn>=1) /* show 'hit enter' sprite */
	blit(141,175,130,12,screen_buffer,menu_picts[20]);

     /* get new menu input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);

      if ((get_and_reset_key_state(UPARROW))||
	   (joystick1.y_axis < joystick1.upthreshold))
       {
	left_bttn=(left_bttn + (5-1)) % 5;
       }
      else if ((get_and_reset_key_state(DOWNARROW)) ||
	      (joystick1.y_axis > joystick1.downthreshold))
       {
	left_bttn=(left_bttn+1) % 5;
	keys_pressed_array[DOWNARROW]=FALSE;
       }
      else if ((get_and_reset_key_state(LEFTARROW))||
	       (joystick1.x_axis < joystick1.leftthreshold))
       {
	 switch (left_bttn)
	  {
	   case (0) /* gmtyp */ :  if (gmtyp_bttn>0) gmtyp_bttn--; break;
	   case (1) /*  slct */ :  if (slct_bttn>0) slct_bttn--; break;
	   case (2) /*  cnfg */:  if (cnfg_bttn>0) cnfg_bttn--; break;
	   case (3) /* view */ :  if (view_bttn>0) view_bttn--; break;
	   default :  break;  /* do nothing */
	  }
	keys_pressed_array[LEFTARROW]=FALSE;
       }

      else if ((get_and_reset_key_state(RIGHTARROW)) ||
	       (joystick1.x_axis > joystick1.rightthreshold))
       {
	 switch (left_bttn)
	  {
	   case (0) /* gmtyp */ :  if (gmtyp_bttn<3) gmtyp_bttn++; break;
	   case (1) /* slct */ :  if (slct_bttn<2) slct_bttn++; break;
	   case (2) /* cnfg  */:  if (cnfg_bttn<2) cnfg_bttn++; break;
	   case (3) /* view */ :  if (view_bttn<2) view_bttn++; break;
	   default :  break;  /* do nothing */
	  }
	keys_pressed_array[RIGHTARROW]=FALSE;
       }

      else if (get_and_reset_key_state(F1)) /* no sound wanted */
       {
	 soundon = !soundon;
       }

      else if (get_and_reset_key_state(ESC))
	 /* quit game wanted */
       {
	 quit_game=TRUE;
       }

      else if ((get_and_reset_key_state(ENTER))||(joystick1.buttonA))
       {
	/* reset joystick button if used for enter key */
	joystick1.buttonA=FALSE;
	delay(100); /* small delay to avoid rapid button press */

	switch (left_bttn)  /* see what row we are in */
	 {
	   case (0) /* gametype */ :
			break;
	   case (1) /* select */ :
			if (slct_bttn==0) /* duel options */
			 {
			  display_duel_options();
			 }
			else if (slct_bttn==1) /* board */
			 {
			  display_board_select_screen();
			 }
			else if (slct_bttn==2) /* difficulty */
			 {
			  display_difficulty_options();
			 }
			break;
	   case (2) /* configure*/ :
			if (cnfg_bttn==0) /* tank types */
			 {
			  display_choose_tank_type_screen();
			 }
			else if (cnfg_bttn==1) /* sound */
			 {
			  display_sound_info();
			 }
			else if (cnfg_bttn==2) /* configure joystick */
			 {
			   configure_joystick();
			 }
			break;
	   case (3) /* look at/view*/ :
			if (view_bttn==0) /* instruction button */
			  display_instructions();
			else if (view_bttn==1) /* game info 1st page */
			 {
			  display_game_info1();
			  display_game_info2();
			  display_game_info3();
			  }
			else if (view_bttn==2) /* me :) */
			  display_picture_of_me();
			break;
	   case (4) /* START GAME! */ :
		     quit_main_menu=TRUE;
		     break;
	 }
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while ((!quit_main_menu) && (!quit_game));

 /* Ok, were done with menu system lets set the appropiate variables */
  gametype = gmtyp_bttn + 1;  /* +1 cuz NOGAME is 0 */

  if (gametype==MATCH)
   {
    /* set the chosen board */
    boardnumber=board_selected;
    /* set the duel options */
    if (duel_options[0]) /* invisible tanks */
     {
      tanks[0].tankstats[VISIBILITYSTATUS] = INVISIBLE;
      tanks[1].tankstats[VISIBILITYSTATUS] = INVISIBLE;
     }
    powerups_on = duel_options[1];
    nightfight = duel_options[2];
    display_stats = duel_options[3];
   }

  else if (gametype==NULL_MODEM_MATCH)
   {
     get_null_modem_info();
   }

 /* Clear screen */
  clear_screen (screen);

 /* Clear the screen buffer */
  clear_screen (screen_buffer);

  /* Lastly, abort game if wanted during menu input */
   if (quit_game)
      do_quit_game_sequence(1);
}
/**************************************************************************/
void display_board_select_screen(void)
/* This function displays to the user the board selection screen. */
{
  int quit_board_menu=FALSE;
  int x,y,i=0;

   do
   {
    /* Clear the screen buffer */
    clear_screen (screen_buffer);

     /*  blit the menu */
     /* First blit the 9 mini board picts */
      i=0;
      for (y=10;y<120;y+=50)
       for (x=25;x<250;x+=90)
       {
	blit (x,y,64,45,screen_buffer,mini_board_picts[i]);
	i++;
       }

     /* Highlight the current selected board by a light green box  */
      x= 23+((board_selected%3)*90);
      y=  8+((board_selected/3)*50);
      rect(x,y,x+68,y+49,GREEN,screen_buffer);

      /* Print out 'use arrow keys' line */
	blit(80,165,153,14,screen_buffer,menu_picts[19]);
      /* Print out 'hit enter' line */
	blit(90,183,130,12,screen_buffer,menu_picts[20]);

     /* get new board select input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);

      if ((get_and_reset_key_state(UPARROW))||
	   (joystick1.y_axis < joystick1.upthreshold))
       {
	 if (board_selected > 2)
	  board_selected-=3;
       }
      else if ((get_and_reset_key_state(DOWNARROW)) ||
	      (joystick1.y_axis > joystick1.downthreshold))
       {
	 if (board_selected < 6)
	  board_selected+=3;
       }
      else if ((get_and_reset_key_state(LEFTARROW))||
	       (joystick1.x_axis < joystick1.leftthreshold))
       {
	 if (board_selected%3)
	  board_selected--;
       }

      else if ((get_and_reset_key_state(RIGHTARROW)) ||
	       (joystick1.x_axis > joystick1.rightthreshold))
       {
	 if ((board_selected+1)%3)
	  board_selected++;
       }

     else if((get_and_reset_key_state(ENTER))||
	     (get_and_reset_key_state(ESC)) ||
	     (joystick1.buttonA) || (joystick1.buttonB))
       {
	 quit_board_menu=TRUE;
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while (!quit_board_menu);

  /* clear the screen buffer */
  clear_screen(screen_buffer);
}
/**************************************************************************/
void display_picture_of_me(void)
/* This is the Look at 'Creator' screen */
{
  int low_memory=FALSE;

    /* Clear the screen buffer */
    clear_screen (screen_buffer);

    /* Clear the screen before palette switch */
    clear_screen (screen);

    /* See if there is enough memory for my pict */
      if((farcoreleft()) < 64000)
       {
	sound(200);delay(5);nosound();
	low_memory=TRUE;
       /* Low mem so lets make room by deleting Main Menu pict for a sec */
	farfree(pcx[TANKMENU].image);
       }

    /* Load my pict in to memory */
  if (loadPCX(pcx_file_names[KCPICT],&pcx[KCPICT]))
     {
       printf(" ERROR loading .DAT file #%d\n",KCPICT);
       sound(300);delay(100);nosound();delay(3000);
       pcx_files_loaded=FALSE;
     }

 /* Now, set the correct color palette for my pict */
  if (pcx_files_loaded==TRUE)
   {
    setpalette(pcx[KCPICT].palette);
   }

   /* Show me */
     blit (0,0,320,200,screen_buffer,pcx[KCPICT].image);
   /* Move the screen buffer to the screen with an assembly function */
     putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   /* Wait for user to press key or joystick button */
    while ((!keypress())&&(!joystick1.buttonA)&&(!joystick1.buttonB))
    {
      /* Read in the joystick input for Joystick A (0) */
	read_joystick (0, &joystick1);
    };
   /* reset the keys array */
    reset_keys_array();
   /* Clear the screen_buffer */
    clear_screen (screen_buffer);
   /* Clear the screen before palette change */
    clear_screen (screen);

 /* Reset the original color palette  */
  if (pcx_files_loaded==TRUE)
   {
    setpalette(pcx[MYTANKS].palette);
   }

  /* Release my image */
  farfree(pcx[KCPICT].image);

  /* Now check if we have low memory, if so we need to reload Main Menu */
  if (low_memory)
   {
    loadPCX(pcx_file_names[TANKMENU],&pcx[TANKMENU]);
   }
}
/**************************************************************************/
void display_instructions(void)
/* This function displays the controls for Tankgame. */
{
  int low_memory=FALSE;

    /* Clear the screen buffer */
    clear_screen (screen_buffer);

    /* Clear the screen before palette switch */
    clear_screen (screen);

  /* See if there is enough memory for my pict */
   if((farcoreleft()) < 64000)
     {
      sound(200);delay(5);nosound();
      low_memory=TRUE;
      /* Low mem so lets make room by deleting Main Menu pict for a sec */
      farfree(pcx[TANKMENU].image);
     }

    /* Load the pict in to memory */
  if (loadPCX(pcx_file_names[TNKCTRLS],&pcx[TNKCTRLS]))
     {
       printf(" ERROR loading .DAT file #%d\n",TNKCTRLS);
       sound(300);delay(100);nosound();delay(3000);
       pcx_files_loaded=FALSE;
     }

 /* Now, set the correct color palette for the pict */
  if (pcx_files_loaded==TRUE)
   {
    setpalette(pcx[TNKCTRLS].palette);
   }

   /* Show the instructions/controls */
     blit (0,0,320,200,screen_buffer,pcx[TNKCTRLS].image);
   /* Move the screen buffer to the screen with an assembly function */
     putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   /* Wait for user to press key or joystick button */
    while ((!keypress())&&(!joystick1.buttonA)&&(!joystick1.buttonB))
    {
      /* Read in the joystick input for Joystick A (0) */
	read_joystick (0, &joystick1);
    };
   /* reset the keys array */
    reset_keys_array();

   /* Clear the screen_buffer */
    clear_screen (screen_buffer);
   /* Clear the screen before palette change */
    clear_screen (screen);

 /* Reset the original color palette  */
  if (pcx_files_loaded==TRUE)
   {
    setpalette(pcx[MYTANKS].palette);
   }

  /* Release the image */
  farfree(pcx[TNKCTRLS].image);

  /* Now check if we have low memory, if so we need to reload Main Menu */
  if (low_memory)
   {
    loadPCX(pcx_file_names[TANKMENU],&pcx[TANKMENU]);
   }
}
/**************************************************************************/
void display_duel_options(void)
/* This function displays the  2 player duel options menu */
{
  static int current_line=0; /* 0-3 possible lines to be on */
  int clr=LOWCOLOR;
  int quit_duel_menu=FALSE;

   do
   {
     /* Clear the screen buffer */
     clear_screen (screen_buffer);

     /*  blit the menu title 'DUEL OPTIONS' */
     fullblit (68,10,175,20,screen_buffer,menu_picts[28]);

     /* draw separation line */
     bar_blit (0,35,320,2,RED,screen_buffer);

     /*  Now blit all four lines......checking to see which are TRUE, */
     /* and what is the current highlighted line. */

     /* BLIT LINE 0 */
     if (current_line==0) /* if line 0 is highlighted */
       clr=HIGHCOLOR;
     else
       clr=LOWCOLOR;
     color_blit (40,50,96,14,clr,screen_buffer,menu_picts[29]);
     color_blit (230,50,25,11,clr,screen_buffer,
		 menu_picts[26+duel_options[0]]);
     /* BLIT LINE 1 */
     if (current_line==1) /* if line 1 is highlighted */
	clr=HIGHCOLOR;
     else
	clr=LOWCOLOR;
     color_blit (40,90,69,14,clr,screen_buffer,menu_picts[30]);
     color_blit (230,90,25,11,clr,screen_buffer,
		 menu_picts[26+duel_options[1]]);
     /* BLIT LINE 2 */
     if (current_line==2) /* if line 2 is highlighted */
	clr=HIGHCOLOR;
     else
	clr=LOWCOLOR;
     color_blit (40,130,68,14,clr,screen_buffer,menu_picts[31]);
     color_blit (230,130,25,11,clr,screen_buffer,
		 menu_picts[26+duel_options[2]]);
     /* BLIT LINE 3 */
     if (current_line==3) /* if line 3 is highlighted */
	clr=HIGHCOLOR;
     else
	clr=LOWCOLOR;
     color_blit (40,170,81,14,clr,screen_buffer,menu_picts[32]);
     color_blit (230,170,25,11,clr,screen_buffer,
		 menu_picts[26+duel_options[3]]);

     /* Get new input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);


      if ((get_and_reset_key_state(UPARROW))||
	   (joystick1.y_axis < joystick1.upthreshold))
       {
	 if (current_line > 0)
	  current_line--;
       }
      else if ((get_and_reset_key_state(DOWNARROW)) ||
	      (joystick1.y_axis > joystick1.downthreshold))
       {
	 if (current_line < 3)
	  current_line++;
       }
      else if ((get_and_reset_key_state(LEFTARROW))||
	       (joystick1.x_axis < joystick1.leftthreshold))
       {
	 duel_options[current_line]=!duel_options[current_line];
       }
      else if ((get_and_reset_key_state(RIGHTARROW)) ||
	       (joystick1.x_axis > joystick1.rightthreshold))
       {
	 duel_options[current_line]=!duel_options[current_line];
       }
     else if((get_and_reset_key_state(ENTER))||
	     (get_and_reset_key_state(ESC)) ||
	     (joystick1.buttonA) || (joystick1.buttonB))
       {
	 quit_duel_menu=TRUE;
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while (!quit_duel_menu);

  /* clear the screen buffer */
  clear_screen(screen_buffer);
}
/**************************************************************************/
void display_difficulty_options(void)
/* This function displays the Choose difficulty menu */
{
  int clr=LOWCOLOR;
  int quit_difficulty_menu=FALSE;

   do
   {
     /* Clear the screen buffer */
     clear_screen (screen_buffer);

     /*  blit the menu title 'Select Difficulty' */
     fullblit (68,10,180,20,screen_buffer,menu_picts[36]);

     /* draw separation line */
     bar_blit (0,35,320,2,RED,screen_buffer);

     /*  Now blit all four lines......checking to see which are TRUE, */
     /* and what is the current highlighted line. */

     /* BLIT LINE 0 */
     if (difficulty_is==EASYDIFF) /* if line 0 is highlighted */
       clr=HIGHCOLOR;
     else
       clr=LOWCOLOR;

     color_blit (124,60,66,14,clr,screen_buffer,menu_picts[33]);

     /* BLIT LINE 1 */
     if (difficulty_is==MEDIUMDIFF) /* if line 1 is highlighted */
	clr=HIGHCOLOR;
     else
	clr=LOWCOLOR;

     color_blit (124,100,66,14,clr,screen_buffer,menu_picts[34]);

     /* BLIT LINE 2 */
     if (difficulty_is==HARDDIFF) /* if line 2 is highlighted */
	clr=HIGHCOLOR;
     else
	clr=LOWCOLOR;

     color_blit (124,140,66,14,clr,screen_buffer,menu_picts[35]);

    if (difficulty_is==EASYDIFF)
    {
     /* Warn user using easy mode.....you don't get secret code */
    out_text(" WARNING",25,165,RED,screen_buffer);
    out_text(" Completing Tankgame on Easy Mode ",25,178,RED,screen_buffer);
    out_text(" will not give you the secret code",25,190,RED,screen_buffer);
    }

      /* Print out 'use arrow keys' line */
       //blit(80,165,153,14,screen_buffer,menu_picts[19]);
      /* Print out 'hit enter' line */
       //blit(90,183,130,12,screen_buffer,menu_picts[20]);

     /* get new input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);

      if ((get_and_reset_key_state(UPARROW))||
	   (joystick1.y_axis < joystick1.upthreshold))
       {
	 if (difficulty_is > EASYDIFF)
	  difficulty_is--;
	 else
	  difficulty_is=HARDDIFF;
       }
      else if ((get_and_reset_key_state(DOWNARROW)) ||
	      (joystick1.y_axis > joystick1.downthreshold))
       {
	 if (difficulty_is < HARDDIFF)
	  difficulty_is++;
	 else
	  difficulty_is=EASYDIFF;
       }
     else if((get_and_reset_key_state(ENTER))||
	     (get_and_reset_key_state(ESC)) ||
	     (joystick1.buttonA) || (joystick1.buttonB))
       {
	 quit_difficulty_menu=TRUE;
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while (!quit_difficulty_menu);

  /* clear the screen buffer */
  clear_screen(screen_buffer);
}
/**************************************************************************/
void display_choose_tank_type_screen(void)
/* This function brings up the tank select menu so the players */
/* can pick what tank types they want to use.                  */
/* RECALL : enum tanktype {NOTANK, SQRTANK, HUNTERKILLER, GUNTANK}; */
{
  int clr=LOWCOLOR;
  int quit_tanktype_menu=FALSE;
  int current_line=0; /* either 0 for Player1 or 1 for Player2 */

  /* Make sure the player's tanks have a type set already */
   if (tanks[0].tanktype==NOTANK) /* player 1 */
      tanks[0].tanktype=SQRTANK;

   if (tanks[1].tanktype==NOTANK) /* player 2 */
      tanks[1].tanktype=SQRTANK;

   do
   {
     /* Clear the screen buffer */
     clear_screen (screen_buffer);

     /*  blit the menu title 'CHOOSE YOUR TANK' */
     fullblit (38,10,176,20,screen_buffer,menu_picts[37]); /* CHOOSE YOUR */
     fullblit (214,10,66,20,screen_buffer,menu_picts[40]); /*    TANK     */

     /* draw separation line */
     bar_blit (0,35,320,2,RED,screen_buffer);

     /*  Now blit both lines......checking to see which are TRUE, */
     /* and what is the current highlighted line. */

     /* BLIT LINE 0 */
     if (current_line==0) /* if Player 1 is highlighted */
       clr=HIGHCOLOR;
     else
       clr=LOWCOLOR;

     /* Blit 'Player 1' */
     color_blit (79,82,61,15,clr,screen_buffer,menu_picts[38]);

     /* Now blit the current Player 1 tank (it is always Green) */
     switch (tanks[0].tanktype)
     {
      case SQRTANK : blit(219,77,SQRTANKPICT_WIDTH,SQRTANKPICT_HEIGHT,
			     screen_buffer,tank_picts[0]);
		     break;
      case HUNTERKILLER : blit(219,77,SQRTANKPICT_WIDTH,SQRTANKPICT_HEIGHT,
			     screen_buffer,tank_picts[32]);
		      break;
      case GUNTANK : blit(219,77,SQRTANKPICT_WIDTH,SQRTANKPICT_HEIGHT,
			  screen_buffer,tank_picts[48]);
		       break;
     }

     /* BLIT LINE 1 */
     if (current_line==1) /* if Player 2 is highlighted */
	clr=HIGHCOLOR;
     else
	clr=LOWCOLOR;

     /* Blit 'Player 2' */
     color_blit (79,130,63,15,clr,screen_buffer,menu_picts[39]);

     /* Now blit the current Player 2 tank (it is always RED) */
     switch (tanks[1].tanktype)
     {
      case SQRTANK : blit(219,125,SQRTANKPICT_WIDTH,SQRTANKPICT_HEIGHT,
			     screen_buffer,tank_picts[16]);
		     break;
      case HUNTERKILLER : blit(219,125,SQRTANKPICT_WIDTH,SQRTANKPICT_HEIGHT,
			     screen_buffer,tank_picts[40]);
		      break;
      case GUNTANK : blit(219,125,SQRTANKPICT_WIDTH,SQRTANKPICT_HEIGHT,
			  screen_buffer,tank_picts[56]);
		       break;
     }

     /* get new input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);

      if ((get_and_reset_key_state(UPARROW))||
	   (joystick1.y_axis < joystick1.upthreshold))
	current_line=!current_line;

      else if ((get_and_reset_key_state(DOWNARROW)) ||
	      (joystick1.y_axis > joystick1.downthreshold))
	current_line=!current_line;

      else if ((get_and_reset_key_state(LEFTARROW))||
	       (joystick1.x_axis < joystick1.leftthreshold))
       {
	if (tanks[current_line].tanktype > SQRTANK)
	  tanks[current_line].tanktype--;
	else
	  tanks[current_line].tanktype=GUNTANK;
       }
      else if ((get_and_reset_key_state(RIGHTARROW)) ||
	       (joystick1.x_axis > joystick1.rightthreshold))
       {
	if (tanks[current_line].tanktype < GUNTANK)
	  tanks[current_line].tanktype++;
	else
	  tanks[current_line].tanktype=SQRTANK;
       }
     else if((get_and_reset_key_state(ENTER))||
	     (get_and_reset_key_state(ESC)) ||
	     (joystick1.buttonA) || (joystick1.buttonB))
       {
	 quit_tanktype_menu=TRUE;
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while (!quit_tanktype_menu);

  /* clear the screen buffer */
  clear_screen(screen_buffer);
}
/**************************************************************************/
void display_sound_info(void)
/* This function displays the sound info menu, which the user can also */
/* select if the sound is to be turned on or left off */
{
  int quit_sound_menu=FALSE;

   do
   {
     /* Clear the screen buffer */
     clear_screen (screen_buffer);

     /*  blit the menu title 'Tankgame Sound' */
     fullblit (42,10,66,20,screen_buffer,menu_picts[40]); /*    TANK     */
     fullblit (105,10,152,20,screen_buffer,menu_picts[41]); /* GAME SOUND  */

     /* draw separation line */
     bar_blit (0,35,320,2,RED,screen_buffer);

     /* blit 'SOUND :' pict */
     fullblit (73,60,75,15,screen_buffer,menu_picts[42]);

     /* Now blit ON or OFF */
     if (soundon)
       fullblit (178,60,25,14,screen_buffer,menu_picts[43]);
     else
       fullblit (173,60,33,14,screen_buffer,menu_picts[44]);

    /* Blit the 'F1' key */
    fullblit (10,98,25,24,screen_buffer,menu_picts[25]);
     /* Toggles sound anytime during Tankgame */
   out_text("Toggles sound anytime during Tankgame",40,105,RED,screen_buffer);
    /* Tankgame uses the PC internal speaker   */
    out_text("Tankgame uses the PC internal speaker",25,135,RED,screen_buffer);
    /* for sound.   Email me for information   */
    out_text("for sound.  Email me for information ",25,147,RED,screen_buffer);
    putpixel(88,154,RED,screen_buffer); /* period */
    /* about the deluxe version of Tankgame  */
    out_text("about the deluxe version of Tankgame",25,159,RED,screen_buffer);
    /* with SoundBlaster support and plenty  */
    out_text("with SoundBlaster support and plenty",25,171,RED,screen_buffer);
    /* of extra features  */
    out_text("of additional features",25,183,RED,screen_buffer);
    putpixel(179,190,RED,screen_buffer); /* period */

     /* get new input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);

      if ((get_and_reset_key_state(LEFTARROW)) ||
	  (get_and_reset_key_state(RIGHTARROW)) ||
	  (joystick1.x_axis < joystick1.leftthreshold) ||
	  (joystick1.x_axis > joystick1.rightthreshold))
       {
	 soundon=!soundon;  /* toggle the global sound variable */
       }
      else if (get_and_reset_key_state(F1)) /* toggle sound */
       {
	 soundon = !soundon;
       }
     else if((get_and_reset_key_state(ENTER))||
	     (get_and_reset_key_state(ESC)) ||
	     (joystick1.buttonA) || (joystick1.buttonB))
       {
	 quit_sound_menu=TRUE;
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while (!quit_sound_menu);

  /* clear the screen buffer */
  clear_screen(screen_buffer);
}
/**************************************************************************/
void configure_joystick(void)
/* This is the joystick calibration routine */
{
  int calibrated=TRUE; /* set to TRUE cuz it should only take 1 loop */
  int try_number=1;  /* current try number on calibration */
  unsigned int XminTemp;	/* Temp variables are used to store the */
  unsigned int YminTemp;	/* results until error checking can be  */
  unsigned int XmaxTemp;	/* done on the values. */
  unsigned int YmaxTemp;
  unsigned int xmin,ymin,xmid,ymid,xmax,ymax;

  do
  {
     /* Clear the screen */
     clear_screen (screen);

    /* print out title */
    out_text (" Joystick calibration ",75,8,YELLOW,screen);

    /* separation line */
    bar_blit (0,35,320,2,RED,screen);

   /* see if joystick is even present */
   if (!joystick1.is_present)
    {
      if (soundon)
	sound(400);delay(250);nosound();
      out_text ("NO JOYSTICK INSTALLED IN PORT A ",50,55,RED,screen);
      delay(2000);
      return;
    }

   /* Ok, joystick is present now calibrate it */
    /* do it by assuming joystick at midpoint and performing */
	out_text("Move joystick to upper left and hit a",10,50,RED,screen);
	out_text("button",10,63,RED,screen);
	/* Wait for user to hit a button */
	wait_for_jstick_button(0, &joystick1, &XminTemp, &YminTemp);
	/* Tell user to move joystick to other extreme (low right) */
	out_text("Move joystick to lower right and hit a",10,90,RED,screen);
	out_text("button",10,103,RED,screen);


	/* Wait for button press */
	wait_for_jstick_button(0, &joystick1, &XmaxTemp, &YmaxTemp);
	/* if the values don't make sense, indicate miscalibration */
	if (XminTemp > XmaxTemp)
	    calibrated = FALSE;
	if (YminTemp > YmaxTemp)
	    calibrated = FALSE;
	if (calibrated==FALSE)
	  {
	   out_text("MISCALIBRATION!! Try again",50,150,RED,screen);
	   try_number++; /* increment try number */
	   delay(2000); /* pause for user to read screen */
	  }

       else /* must have worked..update values */
	 {
	   out_text("  OK ",120,150,RED,screen);

	   xmin = XminTemp;
	   ymin = YminTemp;
	   xmax = XmaxTemp;
	   ymax = YmaxTemp;

	  /* Ok, joystick was calibrated....update the values */
	  /* return values to caller */

	  /* calculate midpoint as average of min and max points */
	   joystick1.x_axis = (xmin + xmax) / 2;
	   joystick1.y_axis = (ymin + ymax) / 2;

	  /* calculate thresholds */
	   joystick1.upthreshold=ymax/3;
	   joystick1.downthreshold=(ymax*2)/3;
	   joystick1.leftthreshold=xmax/3;
	   joystick1.rightthreshold=(xmax*2)/3;

	   delay(1500); /* pause for user to read screen */
	 }

	/* Joystick did not get a valid calibration */
	if(try_number > 3)
	 {
	   sound (250);delay(50);nosound();
	   reset_keys_array(); /* in case use hit ESC during screen */
	   return; /* forget it! 3 trys already */
	 }

   /* Clear the screen */
   clear_screen (screen);
  }
  while (!calibrated);

 /* Lastly, clear the key array in case user hit ESC during configuration */
  reset_keys_array();
}
/**************************************************************************/
void display_game_info1(void)
/* This function displays game info (page 1) for Tankgame */
{
    /* Clear the screen buffer */
    clear_screen (screen_buffer);

    /* Clear the screen before palette switch */
    clear_screen (screen);

   /* Write the info */
    /* Show 'Tankgame Information' text */
    blit (80,10,149,15,screen_buffer,menu_picts[22]);
    /* Draw a line across top */
    line (0,30,319,30,LIGHTGRAY,screen_buffer);

    /* The object of Tankgame in Fullgame  */
    out_text("The object of Tankgame in Fullgame",34,37,RED,screen_buffer);
    /* mode is to get to and complete the  */
    out_text("mode is to get to and complete the",25,49,RED,screen_buffer);
    /* 13th level.  email me the secret  */
    out_text("13th level",25,61,RED,screen_buffer);
    putpixel(95,68,RED,screen_buffer); /* period */
    out_text("Email me the secret",119,61,RED,screen_buffer);
    /* code if you can complete the game */
    out_text(" code if you can complete the game",25,73,RED,screen_buffer);
    /* and I will email you a few hidden */
    out_text("and I will email you a few hidden",25,85,RED,screen_buffer);
    /* codes and some info about the Deluxe */
    out_text("codes and some info about the Deluxe",25,97,RED,screen_buffer);
    /* version of Tankgame with SoundBlaster */
   out_text("version of Tankgame with SoundBlaster",25,109,RED,screen_buffer);
    /* support, 20 different boards, and new */
   out_text("support, 20 different boards, and new ",25,121,RED,screen_buffer);
   /* commas...*/
   putpixel(75,128,RED,screen_buffer); putpixel(75,129,RED,screen_buffer);
   putpixel(74,130,RED,screen_buffer);
   putpixel(222,128,RED,screen_buffer); putpixel(222,129,RED,screen_buffer);
   putpixel(221,130,RED,screen_buffer);
    /* enemies */
   out_text("enemies   good luck and enjoy",25,133,RED,screen_buffer);
   putpixel(75,140,RED,screen_buffer); /* period */
   putpixel(227,140,RED,screen_buffer); /* period */

   /* PUT the picture of the tank */
    blit (120,150,87,37,screen_buffer,menu_picts[23]);

   /* Move the screen buffer to the screen with an assembly function */
    putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));

   /* Wait for user to press key or joystick button */
    while ((!keypress())&&(!joystick1.buttonA)&&(!joystick1.buttonB))
    {
      /* Read in the joystick input for Joystick A (0) */
	read_joystick (0, &joystick1);
    };

    /* reset joystick button if used for enter key */
    joystick1.buttonA=FALSE;
    delay(100);

   /* reset the keys array */
    reset_keys_array();

   /* Clear the screen_buffer */
    clear_screen (screen_buffer);
   /* Clear the screen before palette change */
    clear_screen (screen);
}
/**************************************************************************/
void display_game_info2(void)
/* This function displays game info (page 2) for Tankgame */
{
    /* Clear the screen buffer */
    clear_screen (screen_buffer);

    /* Clear the screen before palette switch */
    clear_screen (screen);

    /* Draw separated box */
    line (5,5,315,5,MAGENTA,screen_buffer); /* top horizontal */
    line (5,39,315,39,MAGENTA,screen_buffer); /* mid horizontal */
    line (5,185,315,185,MAGENTA,screen_buffer); /* bottom horizontal */
    line (5,5,5,185,MAGENTA,screen_buffer); /* left vertical */
    line (315,5,315,185,MAGENTA,screen_buffer); /* right horizontal */

    /* NOW the text */
   out_text("NOTE:  This game version is Freeware.",25,12,RED,screen_buffer);
   putpixel(277,19,RED,screen_buffer); /* period */
   out_text("Please Distribute as much as possible",25,24,RED,screen_buffer);
   putpixel(284,31,RED,screen_buffer); /* period */
   putpixel(60,14,RED,screen_buffer); /* colon dot 1 */
   putpixel(60,17,RED,screen_buffer); /* colon dot 2 */

   out_text("  If you are enjoying this game and",25,50,RED,screen_buffer);
   out_text("are feeling generous, send me a couple",25,62,RED,screen_buffer);
   putpixel(165,69,RED,screen_buffer); /* comma */
   putpixel(165,70,RED,screen_buffer);
   putpixel(164,71,RED,screen_buffer);
   out_text("of bucks to help fund my vampire hour",25,74,RED,screen_buffer);
    /* code if you can complete the game */
   out_text("programming sessions, so i can buy some",25,86,RED,screen_buffer);
    /* and I will email you a few hidden */
   out_text("cocacola and order a pizza.",25,98,RED,screen_buffer);
   putpixel(207,105,RED,screen_buffer); /* period */

 out_text("  Drop me an email line and let me know",25,112,RED,screen_buffer);
 out_text("what you think about the game and i can",25,124,RED,screen_buffer);
 out_text("tell you what im working on now. I hope",25,136,RED,screen_buffer);
   putpixel(242,143,RED,screen_buffer); /* period */
   out_text("you enjoy the game and have fun.",25,148,RED,screen_buffer);
   putpixel(244,155,RED,screen_buffer); /* period */

   /* Move the screen buffer to the screen with an assembly function */
    putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));


   /* Wait for user to press key or joystick button */
    while ((!keypress())&&(!joystick1.buttonA)&&(!joystick1.buttonB))
    {
      /* Read in the joystick input for Joystick A (0) */
	read_joystick (0, &joystick1);
    };

    /* reset joystick button if used for enter key */
    joystick1.buttonA=FALSE;
    delay(100);

   /* reset the keys array */
    reset_keys_array();

   /* Clear the screen_buffer */
    clear_screen (screen_buffer);
   /* Clear the screen before palette change */
    clear_screen (screen);
}
/**************************************************************************/
void display_game_info3(void)
/* This function displays game info (page 3) for Tankgame */
{
    /* Clear the screen buffer */
    clear_screen (screen_buffer);

    /* Clear the screen before palette switch */
    clear_screen (screen);

    /* Draw separated box */
    line (5,5,315,5,MAGENTA,screen_buffer); /* top horizontal */
    line (5,160,315,160,MAGENTA,screen_buffer); /* mid horizontal */
    line (5,195,315,195,MAGENTA,screen_buffer); /* bottom horizontal */
    line (5,5,5,195,MAGENTA,screen_buffer); /* left vertical */
    line (315,5,315,195,MAGENTA,screen_buffer); /* right horizontal */

    /* NOW the text */
   out_text("HERE IS ALL MY CURRENT ADDRESSES",25,12,RED,screen_buffer);
   out_text("SO YOU CAN REACH ME :",25,24,RED,screen_buffer);
   putpixel(160,27,RED,screen_buffer); /* colon dot 1 */
   putpixel(160,30,RED,screen_buffer); /* colon dot 2 */
   /* EMAIL address */
   out_text("EMAIL ",25,40,MAGENTA,screen_buffer);
   out_text("   KMCST138PITT.EDU ",25,52,RED,screen_buffer);
   putpixel(132,59,RED,screen_buffer); /* period */
   /* fix up the 8 to be an @ symbol */
   putpixel(99,57,BLACK,screen_buffer); /* black period */
   putpixel(99,58,BLACK,screen_buffer); /* black period */
   putpixel(97,56,BLACK,screen_buffer); /* black period */
   putpixel(98,55,RED,screen_buffer); /* red period */
   /* WWW address */
   out_text("WORLD WIDE WEB ",25,68,MAGENTA,screen_buffer);
   out_text("   WWW.PITT.EDU/~KMCST13/ ",25,80,RED,screen_buffer);
   putpixel(70,87,RED,screen_buffer); /* period */
   putpixel(105,87,RED,screen_buffer); /* period */
   line (130,89,135,79,RED,screen_buffer); /* first slash */
   line (194,89,199,79,RED,screen_buffer); /* second slash */
   line (138,81,139,80,RED,screen_buffer); /* tilde ~ */
   line (140,81,141,80,RED,screen_buffer); /* tilde ~ */
   /* Residence */
   out_text("RESIDENCE ",25,102,MAGENTA,screen_buffer);
   out_text("   Kirk Christiansen ",25,114,RED,screen_buffer);
   out_text("   3029  Hillcrest Road ",25,126,RED,screen_buffer);
   out_text("   Bethel Park, Pa 15102 ",25,138,RED,screen_buffer);
   /* Copyright info */
   out_text("COPYRIGHT",18,166,MAGENTA,screen_buffer);
   out_text("TANKGAME COPYRIGHT 1995 Kirk Christiansen",
	     18,178,RED,screen_buffer);
   putpixel(74,185,RED,screen_buffer); /* period */

   /* Move the screen buffer to the screen with an assembly function */
    putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));

   /* Wait for user to press key or joystick button */
    while ((!keypress())&&(!joystick1.buttonA)&&(!joystick1.buttonB))
    {
      /* Read in the joystick input for Joystick A (0) */
	read_joystick (0, &joystick1);
    };

    /* reset joystick button if used for enter key */
    joystick1.buttonA=FALSE;
    delay(100);

   /* reset the keys array */
    reset_keys_array();

   /* Clear the screen_buffer */
    clear_screen (screen_buffer);
   /* Clear the screen before palette change */
    clear_screen (screen);
}
/**************************************************************************/
void get_null_modem_info(void)
/* If the user chose a NULL Modem match, then we must ask the user */
/* if he/she is the sender or receiver, and what com port is being used. */
/* This function uses the global variables current_com_port &  */
/* current_local_pc_is. */
{
  int quit_nullmdm_menu=FALSE;
  int current_line=0; /* either 0 for select com port or 1 for */
		      /* select SENDER/RECEIVER */

   do
   {
     /* Clear the screen buffer */
     clear_screen (screen_buffer);

    /* Draw separated box */
    bar_blit (5,5,310,3,MAGENTA,screen_buffer); /* top horizontal */
    bar_blit (5,50,310,3,MAGENTA,screen_buffer); /* mid horizontal */
    bar_blit (5,120,310,3,MAGENTA,screen_buffer); /* mid2 horizontal */
    bar_blit (5,195,310,3,MAGENTA,screen_buffer); /* bottom horizontal */
    bar_blit (5,5,3,190,MAGENTA,screen_buffer); /* left vertical */
    bar_blit (315,5,3,193,MAGENTA,screen_buffer); /* right horizontal */

     /*  blit the menu title 'NULL MODEM SETUP' */
    out_text(" NULL MODEM SETUP ",90,25,GREEN,screen_buffer);

     /* Highlight the current_line, by drawing a rectangle around it */
     if (current_line==0) /* COM PORT LINE */
       rect(55,70,265,100,BLUE,screen_buffer);
     else if (current_line==1) /* SENDER/RECEIVER LINE */
       rect(55,140,265,170,BLUE,screen_buffer);

     /*  Now blit the two stats......checking the values of each, */
     /* Show the com port line */
     if (current_com_port==1)
       out_text (" COM PORT 1 ",110,80,GREEN,screen_buffer);
     else /* com port is set to 2 */
       out_text (" COM PORT 2 ",110,80,GREEN,screen_buffer);

     /* Show the SENDER or RECEIVER line */
     if (current_local_pc_is==SENDER)
       out_text (" SENDER ",115,150,GREEN,screen_buffer);
     else /* com port is set to 2 */
       out_text (" RECEIVER ",115,150,GREEN,screen_buffer);


     /* get new input */
      /* Read in the joystick input for Joystick A (0) */
       read_joystick (0, &joystick1);

      if ((get_and_reset_key_state(UPARROW))||
	   (joystick1.y_axis < joystick1.upthreshold))
	current_line=!current_line;

      else if ((get_and_reset_key_state(DOWNARROW)) ||
	      (joystick1.y_axis > joystick1.downthreshold))
	current_line=!current_line;

      else if ((get_and_reset_key_state(LEFTARROW))||
	       (joystick1.x_axis < joystick1.leftthreshold))
       {
	 if (current_line==0) /* com port line */
	   current_com_port = !current_com_port;
	 else /* sender/receiver line */
	   current_local_pc_is = !current_local_pc_is;
       }
      else if ((get_and_reset_key_state(RIGHTARROW)) ||
	       (joystick1.x_axis > joystick1.rightthreshold))
       {
	 if (current_line==0) /* com port line */
	   current_com_port = !current_com_port;
	 else /* sender/receiver line */
	   current_local_pc_is = !current_local_pc_is;
       }
     else if((get_and_reset_key_state(ENTER))||
	     (get_and_reset_key_state(ESC)) ||
	     (joystick1.buttonA) || (joystick1.buttonB))
       {
	 quit_nullmdm_menu=TRUE;
       }

     /* Move the screen buffer to the screen with an assembly function */
      putwindow(0,0,320,200,FP_OFF(screen_buffer),FP_SEG(screen_buffer));
   }
   while (!quit_nullmdm_menu);

  /* clear the screen buffer */
  clear_screen(screen_buffer);
}
/**************************************************************************/
#endif